from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import Boolean, String, Directory, Int, File

Planemo_Shed_Upload_V0_1_0 = CommandToolBuilder(tool="planemo_shed_upload", base_command=["planemo", "shed_upload"], inputs=[ToolInput(tag="in_recursive", input_type=Boolean(optional=True), prefix="--recursive", doc=InputDocumentation(doc="Recursively perform command for nested\nrepository directories.")), ToolInput(tag="in_fail_fast", input_type=Boolean(optional=True), prefix="--fail_fast", doc=InputDocumentation(doc="If multiple repositories are specified and an\nerror occurs stop immediately instead of\nprocessing remaining repositories.")), ToolInput(tag="in_owner", input_type=String(optional=True), prefix="--owner", doc=InputDocumentation(doc="Tool Shed repository owner (username).")), ToolInput(tag="in_name", input_type=Directory(optional=True), prefix="--name", doc=InputDocumentation(doc="Tool Shed repository name (defaults to the\ninferred tool directory name).")), ToolInput(tag="in_shed_email", input_type=String(optional=True), prefix="--shed_email", doc=InputDocumentation(doc="E-mail for Tool Shed auth (required unless\nshed_key is specified).")), ToolInput(tag="in_shed_key", input_type=String(optional=True), prefix="--shed_key", doc=InputDocumentation(doc="API key for Tool Shed access. An API key is\nrequired unless e-mail and password is\nspecified. This key can be specified with\neither --shed_key or --shed_key_from_env.")), ToolInput(tag="in_shed_key_from_env", input_type=String(optional=True), prefix="--shed_key_from_env", doc=InputDocumentation(doc="Environment variable to read API key for Tool\nShed access from.")), ToolInput(tag="in_shed_password", input_type=String(optional=True), prefix="--shed_password", doc=InputDocumentation(doc="Password for Tool Shed auth (required unless\nshed_key is specified).")), ToolInput(tag="in_shed_target", input_type=Int(optional=True), prefix="--shed_target", doc=InputDocumentation(doc="Tool Shed to target (this can be 'toolshed',\n'testtoolshed', 'local' (alias for\nhttp://localhost:9009/), an arbitrary url or\nmappings defined ~/.planemo.yml.")), ToolInput(tag="in_message", input_type=String(optional=True), prefix="--message", doc=InputDocumentation(doc="Commit message for tool shed upload.")), ToolInput(tag="in_force_repository_creation", input_type=Boolean(optional=True), prefix="--force_repository_creation", doc=InputDocumentation(doc="If a repository cannot be found for the\nspecified user/repo name pair, then\nautomatically create the repository in the\ntoolshed.")), ToolInput(tag="in_check_diff", input_type=Boolean(optional=True), prefix="--check_diff", doc=InputDocumentation(doc="Skip uploading if the shed_diff detects there\nwould be no 'difference' (only attributes\npopulated by the shed would be updated.)")), ToolInput(tag="in_tar_only", input_type=Boolean(optional=True), prefix="--tar_only", doc=InputDocumentation(doc="Produce tar file for upload but do not publish\nto a tool shed.")), ToolInput(tag="in_tar", input_type=File(optional=True), prefix="--tar", doc=InputDocumentation(doc="Specify a pre-existing tar file instead of\nautomatically building one as part of this\ncommand.")), ToolInput(tag="in_one_ones_even", input_type=Int(), position=0, doc=InputDocumentation(doc="Options:"))], outputs=[], container="quay.io/biocontainers/planemo:0.74.3--py_0", version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Planemo_Shed_Upload_V0_1_0().translate("wdl")

